# coding: utf-8

"""
    Apteco API

    An API to allow access to Apteco Marketing Suite resources  # noqa: E501

    The version of the OpenAPI document: v2
    Contact: support@apteco.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class UpsertUserCollectionDetail(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'status': 'str',
        'title': 'str',
        'description': 'str',
        'creation_date': 'datetime',
        'file_path': 'str',
        'deletion_date': 'datetime'
    }

    attribute_map = {
        'status': 'status',
        'title': 'title',
        'description': 'description',
        'creation_date': 'creationDate',
        'file_path': 'filePath',
        'deletion_date': 'deletionDate'
    }

    def __init__(self, status=None, title=None, description=None, creation_date=None, file_path=None, deletion_date=None):  # noqa: E501
        """UpsertUserCollectionDetail - a model defined in OpenAPI"""  # noqa: E501

        self._status = None
        self._title = None
        self._description = None
        self._creation_date = None
        self._file_path = None
        self._deletion_date = None
        self.discriminator = None

        self.status = status
        self.title = title
        self.description = description
        self.creation_date = creation_date
        self.file_path = file_path
        if deletion_date is not None:
            self.deletion_date = deletion_date

    @property
    def status(self):
        """Gets the status of this UpsertUserCollectionDetail.  # noqa: E501

        The status of the collection  # noqa: E501

        :return: The status of this UpsertUserCollectionDetail.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this UpsertUserCollectionDetail.

        The status of the collection  # noqa: E501

        :param status: The status of this UpsertUserCollectionDetail.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["Default", "Pinned", "Archived"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def title(self):
        """Gets the title of this UpsertUserCollectionDetail.  # noqa: E501

        The title of the collection  # noqa: E501

        :return: The title of this UpsertUserCollectionDetail.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this UpsertUserCollectionDetail.

        The title of the collection  # noqa: E501

        :param title: The title of this UpsertUserCollectionDetail.  # noqa: E501
        :type: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def description(self):
        """Gets the description of this UpsertUserCollectionDetail.  # noqa: E501

        The description of the collection  # noqa: E501

        :return: The description of this UpsertUserCollectionDetail.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpsertUserCollectionDetail.

        The description of the collection  # noqa: E501

        :param description: The description of this UpsertUserCollectionDetail.  # noqa: E501
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def creation_date(self):
        """Gets the creation_date of this UpsertUserCollectionDetail.  # noqa: E501

        The date the collection was created  # noqa: E501

        :return: The creation_date of this UpsertUserCollectionDetail.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """Sets the creation_date of this UpsertUserCollectionDetail.

        The date the collection was created  # noqa: E501

        :param creation_date: The creation_date of this UpsertUserCollectionDetail.  # noqa: E501
        :type: datetime
        """
        if creation_date is None:
            raise ValueError("Invalid value for `creation_date`, must not be `None`")  # noqa: E501

        self._creation_date = creation_date

    @property
    def file_path(self):
        """Gets the file_path of this UpsertUserCollectionDetail.  # noqa: E501

        The path to the file that contains the parts of this collection  # noqa: E501

        :return: The file_path of this UpsertUserCollectionDetail.  # noqa: E501
        :rtype: str
        """
        return self._file_path

    @file_path.setter
    def file_path(self, file_path):
        """Sets the file_path of this UpsertUserCollectionDetail.

        The path to the file that contains the parts of this collection  # noqa: E501

        :param file_path: The file_path of this UpsertUserCollectionDetail.  # noqa: E501
        :type: str
        """
        if file_path is None:
            raise ValueError("Invalid value for `file_path`, must not be `None`")  # noqa: E501

        self._file_path = file_path

    @property
    def deletion_date(self):
        """Gets the deletion_date of this UpsertUserCollectionDetail.  # noqa: E501

        The date the collection was deleted, or null if it has not been deleted  # noqa: E501

        :return: The deletion_date of this UpsertUserCollectionDetail.  # noqa: E501
        :rtype: datetime
        """
        return self._deletion_date

    @deletion_date.setter
    def deletion_date(self, deletion_date):
        """Sets the deletion_date of this UpsertUserCollectionDetail.

        The date the collection was deleted, or null if it has not been deleted  # noqa: E501

        :param deletion_date: The deletion_date of this UpsertUserCollectionDetail.  # noqa: E501
        :type: datetime
        """

        self._deletion_date = deletion_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpsertUserCollectionDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
